#define STRICT      // Strict type checking
#include <windows.h>
#include <commdlg.h>
#include <stdio.h>
#include <string.h>
#include <memory.h>
#include <ctype.h>
#include "kxmenuid.h"	// Menu identifiers
#include "kxglobal.h"   // Global variables
#include "kxwproto.h"	// Function Prototypes

static void PASCAL KXCheckMenuItem( BOOL *Flag, int ID )
{
	UINT uCheck;

	if ( *Flag ) {
		*Flag = FALSE;
		uCheck = MF_BYCOMMAND|MF_UNCHECKED;
	} else {
    	*Flag = TRUE;
		uCheck = MF_BYCOMMAND|MF_CHECKED;
	}
    CheckMenuItem( GetMenu(ThisApphWnd), ID, uCheck );
}

void PASCAL CheckGBHZMarkMenu( void )
{
    KXCheckMenuItem( &ShowGBHZMark, IDM_VIEW_HZMARK );
}

void PASCAL CheckTScrollMenu( void )
{
	KXCheckMenuItem( &TrackScroll, IDM_VIEW_TSCROLL );
}

void PASCAL CheckZiTiMenu( void )
{
	if ( CurrentFont ) {
        if ( CurrentFont->JianTi ) {
            CheckMenuItem( GetMenu(ThisApphWnd),
                IDM_VIEW_FANTI, MF_BYCOMMAND|MF_UNCHECKED );
            CheckMenuItem( GetMenu(ThisApphWnd),
                IDM_VIEW_JIANTI, MF_BYCOMMAND|MF_CHECKED );
        } else {
            CheckMenuItem( GetMenu(ThisApphWnd),
                IDM_VIEW_JIANTI, MF_BYCOMMAND|MF_UNCHECKED );
            CheckMenuItem( GetMenu(ThisApphWnd),
				IDM_VIEW_FANTI, MF_BYCOMMAND|MF_CHECKED );
        }
    }
}

void PASCAL CheckSizeMenu( void )
{
    if ( CurrentFont ) {
        if ( CurrentFont->Size == 16 ) {
            CheckMenuItem( GetMenu(ThisApphWnd),
                IDM_FONT_24X24, MF_BYCOMMAND|MF_UNCHECKED );
            CheckMenuItem( GetMenu(ThisApphWnd),
                IDM_FONT_16X16, MF_BYCOMMAND|MF_CHECKED );
        } else {
            CheckMenuItem( GetMenu(ThisApphWnd),
                IDM_FONT_16X16, MF_BYCOMMAND|MF_UNCHECKED );
            CheckMenuItem( GetMenu(ThisApphWnd),
				IDM_FONT_24X24, MF_BYCOMMAND|MF_CHECKED );
        }
    }
}

void PASCAL CheckEncodeMenu( void )
{
	static int OldEncode = INVALID_MODE;
	UINT uMenuID;

	switch( OldEncode ) {
		case ASCII:	uMenuID = IDM_VIEW_ASCII; break;
		case BIG5: uMenuID = IDM_VIEW_BIG5; break;
		case GB: uMenuID = IDM_VIEW_GB; break;
		case HZ: uMenuID = IDM_VIEW_HZ; break;
        default: uMenuID = 0; break;			
	}
	if ( uMenuID )
		CheckMenuItem( GetMenu(ThisApphWnd),
			uMenuID, MF_BYCOMMAND|MF_UNCHECKED);
	switch( Encoding ) {
		case ASCII:	uMenuID = IDM_VIEW_ASCII; break;
		case BIG5: uMenuID = IDM_VIEW_BIG5; break;
		case GB: uMenuID = IDM_VIEW_GB; break;
		case HZ: uMenuID = IDM_VIEW_HZ; break;
		default: uMenuID = 0; break;
	}
	if ( uMenuID ) {
		CheckMenuItem( GetMenu(ThisApphWnd),
			uMenuID, MF_BYCOMMAND|MF_CHECKED );
		OldEncode = Encoding;
	}
}


