#include <stdio.h>
#include <string.h>
#define STRICT
#include <windows.h>
#include "kxtype.h"
#include "kxglobal.h"
#include "kxwproto.h"

static int OldRow = -1, OldCol = -1;
static FILE *ShengZiFPtr = 0;
static ShengZiEncode = INVALID_MODE;

void PASCAL KXGetChnCompReset( void )
{
	OldRow = OldCol = -1;
}

int PASCAL PrintToShengZi( char *s, char *s2 )
{
	if ( !ShengZiFPtr || ShengZiEncode != Encoding )
        if ( OpenShengZiFile() < 0 ) return 0;
    fprintf( ShengZiFPtr, "%s%s", s, s2 );
    return 1;
}

void PASCAL CloseShengZiFile( void )
{
	if ( ShengZiFPtr ) {
		fclose(ShengZiFPtr);
		ShengZiFPtr = 0;
		ShengZiEncode = INVALID_MODE;
    }
}

int PASCAL OpenShengZiFile( void )
{
	int I;
	char FName[512];

    CloseShengZiFile();
	I = GetPrivateProfileString( "KuaiXue", "ShengZiDir", 0,
		FName, 512, "kxwin.ini" );
    if ( I && FName[I]  != '\\' )
        strcat(FName, "\\" );
    strcat( FName, "shengzi");
    switch( Encoding ){
    case BIG5: strcat(FName, ".b5"); break;
    case GB:   strcat(FName, ".gb"); break;
	case HZ:   strcat(FName, ".hz"); break;
    default:   return -1;
	}
	ShengZiFPtr = fopen( FName, "a+" );
	if ( ShengZiFPtr == NULL ) return -2;

    ShengZiEncode = Encoding;

    return 0;
}

static BYTE PASCAL ByteTypeBig5_GB( BYTE *buf, int C )
{
	int i = 0;
	while(1) {
		if ( buf[i] == 0 ) return 0;
		if ( buf[i] > 0xa0 ) {
			if ( C == i ) return HZ_BYTE1;
            i ++;
			if ( C == i ) return HZ_BYTE2;
			i ++;
		} else i ++;
		if ( i > C ) return ASCIIBYTE;
		if ( i >= MAXCOL ) return 0;
	}
}

static BYTE PASCAL ByteTypeHZ( char *buf, int *CPtr )
{
	int i = 0, HZOn = 0, C = *CPtr;
	while(1) {
		if ( buf[i] == 0 ) return 0;
		if ( buf[i] == '~' ) {
			i ++;
			if ( HZOn ) {
				if ( buf[i] == '}' ) {
					if ( !ShowGBHZMark ) C += 2;
					HZOn = 0;
				}
			} else if ( buf[i] == '{' ) {
				if ( !ShowGBHZMark ) C += 2;
				HZOn = 1;
			} else
				continue;
			*CPtr = C;
		} else if ( HZOn ) {
			if ( C == i++ ) return HZ_BYTE1;
			if ( C == i ) return HZ_BYTE2;
		}
		i ++;
		if ( i > C ) return ASCIIBYTE;
		if ( i >= MAXCOL ) return 0;
	}
}

static BYTE PASCAL ByteType( char *buf, int *CPtr )
{
	switch( Encoding ) {
	case BIG5:  return ByteTypeBig5_GB(buf, *CPtr);
	case HZ:    return ByteTypeHZ(buf, CPtr);
	case ASCII: return ASCIIBYTE;
	default:    return ByteTypeBig5_GB(buf, *CPtr);
	}
}

LPSTR ToBin( BYTE Sqr, int l );


static void PASCAL CopyFromAbove( BYTE *P, int CmpIdx )
{
	int I = 0;
	while( *P ) { I ++; P ++; } // Advance to end of line.
	if ( Encoding == HZ && I > 0 && *(--P) == '~' ) { I -= 2; P --; }
	while( I >= 0 && *P < 33 ) { // ignore all spaces
		I --; P --;
	}
	// We better has at least two chinese characters to make a compound
	if ( I < 3 ) return;
	while( I >= 0 && CmpIdx >= 0 ) {  // Copy to compound
		if ( Encoding == HZ && *(P-1) == '~' ) {
			P -= 2;
			I -= 2;
			continue;
		}
		ChnComp[CmpIdx--] = *P--;
        ChnComp[CmpIdx--] = *P--;
		I -= 2;
    }
}

static void PASCAL CopyFromBelow( BYTE *P, int CmpIdx )
{
	int I = 0, J = 0;
	BYTE *OP;
	// ignore all spaces
	while( *P && *P < 33 ) { I ++; J ++; P ++; }
    if ( !(*P) ) return;
	// Count chars
	OP = P;
	while( *P && *P > 32 ) { J ++; P ++; }
	// we better has more at least two chinese chars
	if ( J - I < 3 ) return;
	I = 0;
	while( *OP && CmpIdx < COMP_BYTES ) { // Copy to compound
		if ( Encoding == HZ && ( *OP == '~' ) ) {
			OP ++;
			if ( *OP ) OP ++;
			continue;
		}
		ChnComp[CmpIdx++] = *OP++;
		ChnComp[CmpIdx++] = *OP++;
	}
}

int PASCAL KXGetChnComp(TextWin *TW, int NewRow, int NewCol)
{
	BYTE			*P, *OP = 0;
	int 			I,
                    J,
                    StartCol,
					StartRow;
	BYTE            BType;

	P = TW->Buf + BufRowPtr(NewRow);
	BType = ByteType(P, &NewCol );

    if ( BType && IsHZByte(BType) ) {
		if ( IsHZByte2(BType)) {
			NewCol--;
        }
		if ( NewCol < 0 ) return 0;
		if ( NewRow == OldRow && NewCol == OldCol ) return 0;
	} else {
/*		wsprintf(CommonBuffer, "Invalid: char: %u",
			P[NewCol] );
		MessageBox( ThisApphWnd, CommonBuffer, "IN", MB_OK );*/
		return 0;
    }

	if ( OldRow != NewRow ) {
		PrintToShengZi( "---\n", "" );
        PrintToShengZi( P, "\n" );
    }
/*
	for (I = 0; I < NewCol; I++)
        fputc(' ', ShengZiFPtr);
    fprintf(ShengZiFPtr, "^^\n");
*/
	P += NewCol;
	OldRow = NewRow;
    OldCol = NewCol;

	for (J = 0; J < COMP_BYTES; J++) ChnComp[J] = 0;
	J = CLICKC_BYTE1_POS;
	StartRow = NewRow;

	/* Copy Clicked character into compound */
	ChnComp[J++] = *P++;
	ChnComp[J++] = *P++;
	/* Copy into last section of the compound */
	for (I = NewCol + 2; J < COMP_BYTES; I++) {
		if ( *P < 33 && P > OP) {
			OP = P;
			while( *OP && *OP < 33 ) { OP ++; }
			if ( *OP == 0 ) P = OP;
		}
		if ( *P == 0 ) {
			if (StartRow >= TW->BufRows) break;
			StartRow ++;
			P = TW->Buf + BufRowPtr(StartRow);
/*			wsprintf(CommonBuffer,
				"Below: Col: %d ThisRow: %d  NextRow: %d CIdx: %d",
				I, NewRow, StartRow, J );
			MessageBox( ThisApphWnd, CommonBuffer, "BE", MB_OK );*/
			CopyFromBelow( P, J );
            break;
		}
		if ( Encoding == HZ && ( *P == '~' ) ) {
			P ++;
            I ++;
            if ( *P ) { P ++; I ++; }
			continue;
		}
		ChnComp[J++] = *P++;
		I ++;
		ChnComp[J++] = *P++;
	}

	/* Copy into first section of the compound */
	J = CLICKC_BYTE1_POS - 1;
	StartRow = NewRow, StartCol = NewCol - 1;
	P = TW->Buf + BufRowPtr(StartRow) + StartCol;
	OP = P+1;

	for (I = StartCol; J >= 0; I--) {
		if ( I > 0 && *P < 33 && OP > P ) {
			OP = P;
			while( I > 0 && *OP < 33 ) { OP --; I --; }
			if ( I == 0 ) I --;
		} 
		if (I < 0) {
            if (StartRow <= 0 )  break;
			StartRow --;
			P = TW->Buf + BufRowPtr(StartRow);
/*			wsprintf(CommonBuffer,
				"Above: Col: %d ThisRow: %d  LastRow: %d CIdx: %d",
				I, NewRow, StartRow, J );
			MessageBox( ThisApphWnd, CommonBuffer, "BE", MB_OK );*/
			CopyFromAbove( P, J );
			break;
		}
		if ( Encoding == HZ && *(P-1) == '~' ) {
			P -= 2;
			I -= 2;
			continue;
		}
		ChnComp[J--] = *P--;
		I --;
		ChnComp[J--] = *P--;
	}
    return 1;
}

