#ifndef _KXWPROTO_H_
#define _KXWPROTO_H_

//
// Prototypes
//
// Enter and exit application
						// hInst	PrevhInst   CmdLine  nCmdShow
	BOOL PASCAL EnterApp( HINSTANCE, HINSTANCE, LPSTR,   int );
    void PASCAL ExitApp( void );
    void PASCAL Quit( void );
    void PASCAL InitGlobal( void );
// Message Receivers
    LRESULT CALLBACK _export KXWndProc( HWND, UINT, WPARAM, LPARAM );
	LRESULT CALLBACK _export KXTextWndProc( HWND, UINT, WPARAM, LPARAM );
// Application initializer
 // success?				// hInst	 PrevhInst
    BOOL PASCAL InitKXWindow( HINSTANCE, HINSTANCE );
// Functions to handle font loading
	BOOL PASCAL InitChFont( TextWin *, ChFontInfo * );
	void PASCAL DeleteChFont( void );
// Function to handle window size
	void PASCAL GetWindowSize( void );
							// ..	   did window resize?
	void PASCAL AdjustTextWin( TextWin *, BOOL );
	BOOL PASCAL ReadFontInfoFromIni( ChFontInfo * );
// Functions to handle file I/O
  // all three return success status.
    BOOL PASCAL LoadToScrBuffer( TextWin *);
    BOOL PASCAL ReadFile( TextWin *);
    BOOL PASCAL OpenNewFile( TextWin *);
	void PASCAL SaveBookMark( FileInfo *, int );
	void PASCAL GotoBookMark( FileInfo * );
	void PASCAL CloseFile( TextWin *);
	void PASCAL GetBanner( TextWin *);
 // success?				// ..	   begin row  end row
	BOOL PASCAL EraseBuffer( TextWin *, int, 	    int );
 // Rows printed			// ..		  row  col	str	 wraping
	int  PASCAL PrintToBuffer( TextWin *, int, int, char*, int);
#define TW_WRAPNON 0
#define TW_WRAPBUF 1
#define TW_WRAPWIN 2
// Different Encoding display functions
    void PASCAL RefreshScreen( TextWin *);
    void PASCAL RefreshScreenGB( TextWin *);
    void PASCAL RefreshScreenBig5( TextWin *);
    void PASCAL RefreshScreenHZ( TextWin *);
    void PASCAL RefreshScreenASCII( TextWin *);
// Encoding handling function.
  // changed?				// ..		New Coding
	BOOL PASCAL ChangeEncode( TextWin *, int );
// Functions to do scrolling
  // Lines seeked			// ..	   # of lines( positive )
	int  PASCAL SeekForward( TextWin *, int );
  // ditto					// ditto
	int  PASCAL SeekBackward( TextWin *, int );
  // scrolled?				// neg: up  pos(+): down
	BOOL PASCAL FileVertScroll( int );
    						// ditto
	void PASCAL VertScroll( int );
    void PASCAL RespondToVScroll( WPARAM, LPARAM );
// Functions to handle menu state changes
    void PASCAL CheckGBHZMarkMenu( void );
    void PASCAL CheckEncodeMenu( void );
    void PASCAL CheckTScrollMenu( void );
    void PASCAL CheckZiTiMenu( void );
    void PASCAL CheckSizeMenu( void );
    BOOL PASCAL RespondToMenu( WPARAM );

// Function to handle keyboard input.
    void PASCAL RespondToKeyDown( WPARAM wParam );

// Function to pick up Chinese compounds.
    void PASCAL KXGetChnCompReset( void );
    //				// TextWin	NewRow  NewCol
    int PASCAL KXGetChnComp(TextWin *, int,    int );
	int PASCAL OpenShengZiFile( void );
    void PASCAL CloseShengZiFile( void );
    int PASCAL PrintToShengZi( char *s, char *s2 );

// Dictionary functions;
	//			        DictIdx        DictBuf  DictSize
    int  PASCAL KXLookUpSingle(long *, BYTE HUGE *, long );
    int  PASCAL KXLookup      (long *, BYTE HUGE *, long );
    // 					DictBuf	 DictFileName
    long  PASCAL KXReadDict( BYTE HUGE *, char *);
    LPSTR PASCAL KXReadDictErrStr( long );
    // foundmark
    long  PASCAL KXNextFoundCompound( void );
	// total found			dictptr     dictsize
    int   PASCAL KXLookUpCompound( BYTE HUGE *, long );

//
// End prototypes
//

#endif
